// MConf.cpp: MConf NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ntool.h"
#include "MConf.h"
#include "nConfSection.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

MConf::MConf()
:m_pSetting(NULL),m_nTopicsMax(0),m_nFilterMax(0)
{
	// CX^X𐶐
	if(m_pSetting == NULL)
	{
		m_pSetting = MSetting::GetInstance();
	}
	
	m_cPath = m_pSetting->GetConfPath();
	ReadFile();
}

MConf::~MConf()
{
	MSetting::DeleteInstance();
}

CString MConf::GetPath()
{
	return m_cPath;
}

int MConf::SetPath(const CString &rPath)
{
	m_cPath = rPath;
	return 0;
}



CString MConf::GetLogDirectory()
{
	CString cBuf = m_mData[LOG_DIRECTORY];
	cBuf.Replace(_T("'"),_T(""));
	cBuf.Replace(_T("/"),_T("\\"));
	return cBuf;
}



MConf* MConf::m_pConf = NULL;
int	   MConf::m_nRef = 0;
MConf* MConf::GetInstance()
{
	m_nRef++;
	if(m_pConf == NULL)
	{
		m_pConf = new MConf;
	}
	return m_pConf;
}

void MConf::DeleteInstance()
{
	m_nRef--;
	
	if(m_nRef == 0)
	{
		delete m_pConf;
	}
}

void MConf::ReadFile()
{
	if(m_cPath == _T(""))
	{
		DebugMsg(_T("pX"));
		return;
	}

	// s͂
	CStdioFile cFile;
	if(cFile.Open(m_cPath,CFile::modeRead) == 0)
	{
		DebugMsg("t@CJȂ`");
		cFile.Close();
	}

	CString cBuffer,cName,cData;
	int i = 0;
	while(cFile.ReadString(cBuffer))
	{
		// RgȂ炷Ƃ΂
		if(cBuffer == _T("=begin") || cBuffer == _T("=end"))
		{
			i = !i;
			continue;
		}

		if(i != 0 || cBuffer.Left(1) == _T("#") || cBuffer == _T(""))
		{
			continue;
		}


		// gsbNXEtB^`FbN
		if(ReadFilter(cBuffer) == 0)
		{
			continue;
		}
		if(ReadTopics(cBuffer) == 0)
		{
			continue;
		}

		// ꉞA"="邩`FbN
		int n = cBuffer.Find(_T("="));
		if( n != -1)
		{
			// f[^Zbg
			cName = cBuffer.Left(n);
			cData = cBuffer.Mid(n+1);

			cName.TrimLeft();
			cName.TrimRight();
			cData.TrimLeft();
			cData.TrimRight();
			m_mData[cName] = cData;
		}
	}

}

int MConf::ReadFilter(const CString &rData)
{
	if(rData.Left(strlen("FILTER")) == "FILTER")
	{
		int n = rData.Find(_T("="));
		if( n != -1)
		{
			CString cFilter;
			// f[^Zbg
			cFilter = rData.Mid(n+1);

			cFilter.TrimLeft();
			cFilter.TrimRight();
			
			m_liFilter.push_back(cFilter);
			m_nFilterMax++;
		}
		return 0;
	}
	return -1;
}

int MConf::ReadTopics(const CString &rData)
{
	// ܂́A= ŕ
	CString cName,cData;
	int i = rData.Find("=");
	if(i == -1){return -1;}

	cName = rData.Left(i);
	cData = rData.Mid(i+1);

	cName.TrimLeft();
	cName.TrimRight();
	cData.TrimLeft();
	cData.TrimRight();

	if(cName != _T("TOPIC")){return -1;}

	TOPICS stTopics;
	i = cData.Find("\t");
	if( i != -1)
	{
		stTopics.cFile = cData.Left(i);
		stTopics.cKey  = cData.Mid(i+1);
	}else{
		stTopics.cFile= cData;
	}

	m_liTopics.push_back(stTopics);
	m_nTopicsMax++;
	return 0;
}

int MConf::SetLogDirectory(const CString &rPath)
{
	// ܂́A"\"to"/"
	CString cPath = rPath;
	cPath.Replace(_T("\\"),_T("/"));
	// 'ł
	cPath = _T("'") + cPath +_T("'");
	m_mData[LOG_DIRECTORY] = cPath;
	return 0;
}

CString MConf::GetOutputDirectory()
{
	CString cBuf = m_mData[OUTPUT_DIRECTORY];
	cBuf.Replace(_T("'"),_T(""));
	cBuf.Replace(_T("/"),_T("\\"));
	return cBuf;	
}

int MConf::SetOutputDirectory(const CString &rPath)
{
	// ܂́A"\"to"/"
	CString cPath = rPath;
	cPath.Replace(_T("\\"),_T("/"));
	// 'ł
	cPath = _T("'") + cPath +_T("'");
	m_mData[OUTPUT_DIRECTORY] = cPath;
	return 0;
}

CString MConf::GetTopicChar()
{
	CString cBuf = m_mData[TOPIC_CHAR];
	DelQuote(cBuf);
	return cBuf;
}

void MConf::DelQuote(CString &rStr)
{
	rStr.Replace(_T("'"),_T(""));
}

int MConf::SetTopicChar(const CString &rData)
{
	CString cBuf = rData;
	AddQuote(cBuf);
	m_mData[TOPIC_CHAR] = cBuf;
	return 0;
}

void MConf::AddQuote(CString &rBuf)
{
	rBuf = _T("'") + rBuf +_T("'");		
}

BOOL MConf::GetParagraphAnchor()
{
	if(m_mData[PARAGRAPH_ANCHOR] == _T("true"))
	{
		return TRUE;
	}else{
		return FALSE;
	}
}

int MConf::SetParagraphAnchor(BOOL b)
{
	if(b)
	{
		m_mData[PARAGRAPH_ANCHOR] = _T("true");
	}else{
		m_mData[PARAGRAPH_ANCHOR] = _T("false");
	}
	return 0;
}

BOOL MConf::GetLF2BR()
{
	if(m_mData[LF2BR] == _T("true"))
	{
		return TRUE;
	}else{
		return FALSE;
	}
}

int MConf::SetLE2BR(BOOL b)
{
	if(b)
	{
		m_mData[LF2BR] = _T("true");
	}else{
		m_mData[LF2BR] = _T("false");
	}
	return 0;
}

int MConf::GetOutputKCode()
{
	return atoi(m_mData[OUTPUT_KCODE]);
}

int MConf::SetOutputKCode(int nCode)
{
	// ꉞG[`FbN
	if( nCode < 1 || 3 < nCode)
	{
		return -1;
	}

	char chBuf[3];
	itoa(nCode,chBuf,10);
	m_mData[OUTPUT_KCODE] = chBuf;
	return 0;
}

BOOL MConf::GetShowVersion()
{
	if(m_mData[SHOW_VERSION] == _T("true"))
	{
		return TRUE;
	}else{
		return FALSE;
	}
}

int MConf::SetShowVersion(BOOL b)
{
	if(b)
	{
		m_mData[SHOW_VERSION] = _T("true");
	}else{
		m_mData[SHOW_VERSION] = _T("false");
	}
	return 0;
}

int MConf::SetMaxDiary(int nMax)
{
	char chBuf[100];
	itoa(nMax,chBuf,10);
	m_mData[MAX_DIARY] = chBuf;
	return 0;
}

int MConf::GetMaxDiary()
{
	int nRes = atoi(m_mData[MAX_DIARY]);
	
	return nRes;
}

int MConf::SetLastestFileName(const CString &rPath)
{
	CString cPath = rPath;
	AddQuote(cPath);
	m_mData[LASTEST_FILENAME] = cPath;

	return 0;

}

CString MConf::GetLastestFileName()
{
	CString cPath = m_mData[LASTEST_FILENAME];
	DelQuote(cPath);
	return cPath;
}

int MConf::SetDateFormatLastest(const CString &rFormat)
{
	CString cFormat = rFormat;
	AddQuote(cFormat);
	m_mData[DATEFORMAT_LASTEST] = cFormat;

	return 0;
}

CString MConf::GetDateFormatLastest()
{
	CString cFormat = m_mData[DATEFORMAT_LASTEST];
	DelQuote(cFormat);
	
	return cFormat;
}

int MConf::SetHeaderLastest(const CString &rHeader)
{
	CString cHeader = rHeader;
	AddQuote(cHeader);
	m_mData[HEADER_LASTEST] = cHeader;
	return 0;
}

CString MConf::GetHeaderLastest()
{
	CString cHeader = m_mData[HEADER_LASTEST];
	DelQuote(cHeader);
	return cHeader;
}

CString MConf::GetSkeltonLastest()
{
	CString cSkelton = m_mData[SKELTON_LASTEST];
	DelQuote(cSkelton);
	return cSkelton;
}	

int MConf::SetSkeltonLastest(const CString &rSkelton)
{
	CString cSkelton = rSkelton;
	AddQuote(cSkelton);
	m_mData[SKELTON_LASTEST] = cSkelton;
	return 0;
}

CString MConf::GetSplitLastest()
{
	CString cSplit = m_mData[SPLIT_LASTEST];
	DelQuote(cSplit);
	return cSplit;

}

int MConf::SetSplitLastest(const CString &rSplit)
{
	CString cSplit = rSplit;
	AddQuote(cSplit);
	m_mData[SPLIT_LASTEST] = cSplit;
	return 0;
}

CString MConf::GetMonthPartName()
{
	CString cName = m_mData[MONTH_PART_NAMES];
	return cName;
}

int MConf::SetMonthPartName(const CString &rName)
{
	m_mData[MONTH_PART_NAMES] = rName;
	return 0;
}

CString MConf::GetDateFormatPastDay()
{
	CString cFormat = m_mData[DATEFORMAT_PASTDAYS];
	DelQuote(cFormat);
	return cFormat;
}

int MConf::SetDateFormatPastDay(const CString &rFormat)
{
	CString cFormat = rFormat;
	AddQuote(cFormat);
	m_mData[DATEFORMAT_PASTDAYS] = cFormat;
	return 0;
}

CString MConf::GetHeaderPastDay()
{
	CString cSkelton = m_mData[HEADER_PASTDAYS];
	DelQuote(cSkelton);
	return cSkelton;
}

int MConf::SetSkeltonPastDay(const CString &rSkelton)
{
	CString cSkelton = rSkelton;
	AddQuote(cSkelton);
	m_mData[SKELTON_PASTDAYS] = cSkelton;
	return 0;
}

CString MConf::GetSplitPastDay()
{
	CString cSplit = m_mData[SPLIT_PASTDAYS];
	DelQuote(cSplit);
	return cSplit;
}

int MConf::SetSplitPastDay(const CString &rSplit)
{
	CString cSplit = rSplit;
	AddQuote(cSplit);
	m_mData[SPLIT_PASTDAYS] = cSplit;
	return 0;
}

CString MConf::GetTopicMonthFormat()
{
	CString cSplit = m_mData[TOPIC_MONTH_FORMAT];
	DelQuote(cSplit);
	return cSplit;	
}

int MConf::SetTopicMonthFormat(const CString &rFormat)
{
	CString cSplit = rFormat;
	AddQuote(cSplit);
	m_mData[TOPIC_MONTH_FORMAT] = cSplit;
	return 0;
}

CString MConf::GetTopicDateFormat()
{
	CString cSplit = m_mData[TOPIC_DATE_FORMAT];
	DelQuote(cSplit);
	return cSplit;
}

int MConf::SetTopicDateFormat(const CString &rFormat)
{
	CString cSplit = rFormat;
	AddQuote(cSplit);
	m_mData[TOPIC_DATE_FORMAT] = cSplit;
	return 0;
}

CString MConf::GetFilter(int nIndex)
{
	list<CString>::iterator i;
	i = m_liFilter.begin();
	for(int n = 0 ; n < nIndex ; n++)
	{
		i++;
	}
	CString str = *i;
	DelQuote(str);
	return str;
}

int MConf::AddFilter(CString cFilter)
{
	AddQuote(cFilter);
	m_nFilterMax++;
	m_liFilter.push_back(cFilter);
	return 0;
}

BOOL MConf::GetAnchorEachTopics()
{
	if(m_mData[ANCHOR_EACH_TOPIC] == _T("true"))
	{
		return TRUE;
	}else{
		return FALSE;
	}
}

int MConf::SetAnchorEachTopics(BOOL b)
{
	if(b)
	{
		m_mData[ANCHOR_EACH_TOPIC] = _T("true");
	}else{
		m_mData[ANCHOR_EACH_TOPIC] = _T("false");
	}
	return 0;
}

int MConf::GetTopics(int nIndex, CString &rKey, CString &rData)
{
	list<TOPICS>::iterator i;
	i = m_liTopics.begin();

	for(int n=0 ; n < nIndex; n++)
	{
		i++;
	}
	TOPICS stTopics = *i;

	rKey = stTopics.cKey;
	rData = stTopics.cFile;
	return 0;
}

int MConf::SetTopics(CString cKey, CString cData)
{
	TOPICS stTopics;
	stTopics.cKey = cKey;
	stTopics.cFile = cData;
	m_nTopicsMax++;
	m_liTopics.push_back(stTopics);

	return 0;
}

void MConf::WriteFile()
{
	CString cBuf;

	// ܂͕ʂ̃f[^
	map<CString,CString>::iterator i;
	for(i = m_mData.begin() ; i != m_mData.end() ; i++)
	{
		cBuf += i->first + " = " + i->second + "\n";
	}
	
	// ̓tB^
	list<CString>::iterator iFilter;
	for(iFilter = m_liFilter.begin() ; iFilter != m_liFilter.end() ; iFilter++)
	{
		cBuf += "FILTER = " + *iFilter + "\n";
	}

	// ŌɃgsbNX
	list<TOPICS>::iterator iTopics;
	TOPICS stTemp;
	for(iTopics = m_liTopics.begin() ; iTopics != m_liTopics.end() ; iTopics++)
	{
		stTemp = *iTopics;
		if(stTemp.cKey != "")
		{
			cBuf += "TOPIC = " + stTemp.cFile + "\t" + stTemp.cKey +"\n";
		}else{
			cBuf += "TOPIC = " + stTemp.cFile + "\n";
		}
	}

	CStdioFile cFile;
	if(cFile.Open(m_cPath,CFile::modeWrite | CFile::modeCreate) == 0)
	{
		cFile.Close();
		return;
	}

	cFile.WriteString(cBuf);
	cFile.Close();
}

CString MConf::GetSkeltonPastDay()
{
	CString cSkelton = m_mData[SKELTON_PASTDAYS];
	DelQuote(cSkelton);
	return cSkelton;
}



int MConf::SetHeaderPastDay(const CString &rHeader)
{
	CString cHeader = rHeader;
	AddQuote(cHeader);
	m_mData[HEADER_PASTDAYS] = cHeader;
	return 0;
}

int MConf::GetTopicsCount()
{
	return m_nTopicsMax;
}

void MConf::ClearTopcs()
{
	m_nTopicsMax = 0;
	m_liTopics.clear();
}

void MConf::FilterClear()
{
	m_liFilter.clear();
	m_nFilterMax = 0;
}

int MConf::GetFilterMax()
{
	return m_nFilterMax;
}
